---
title: CSS numeric factory functions
slug: Web/API/CSS/factory_functions
tags:
  - API
  - CSS
  - CSS API
  - Houdini
  - Reference
  - factory function
---
<p>{{SeeCompatTable}}<span class="seoSummary">The <strong>CSS numeric factory functions</strong></span>, such as <code>CSS.em()</code> and <code>CSS.turn()</code> <span class="seoSummary">are methods that return <a href="/en-US/docs/Web/API/CSSUnitValue">CSSUnitValues</a> with the value being the numeric argument and the unit being the name of the method used.</span> These functions create new numeric values less verbosely than using the {{domxref('CSSUnitValue.CSSUnitValue()')}} constructor.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">CSS.number(<var>number</var>);
CSS.percent(<var>number</var>);

// &lt;length&gt;
CSS.em(<var>number</var>);
CSS.ex(<var>number</var>);
CSS.ch(<var>number</var>);
CSS.ic(<var>number</var>);
CSS.rem(<var>number</var>);
CSS.lh(<var>number</var>);
CSS.rlh(<var>number</var>);
CSS.vw(<var>number</var>);
CSS.vh(<var>number</var>);
CSS.vi(<var>number</var>);
CSS.vb(<var>number</var>);
CSS.vmin(<var>number</var>);
CSS.vmax(<var>number</var>);
CSS.cm(<var>number</var>);
CSS.mm(<var>number</var>);
CSS.Q(<var>number</var>);
CSS.in(<var>number</var>);
CSS.pt(<var>number</var>);
CSS.pc(<var>number</var>);
CSS.px(<var>number</var>);

// &lt;angle&gt;
CSS.deg(<var>number</var>);
CSS.grad(<var>number</var>);
CSS.rad(<var>number</var>);
CSS.turn(<var>number</var>);

// &lt;time&gt;
CSS.s(<var>number</var>);
CSS.ms(<var>number</var>);

// &lt;frequency&gt;
CSS.Hz(<var>number</var>);
CSS.kHz(<var>number</var>);

// &lt;resolution&gt;
CSS.dpi(<var>number</var>);
CSS.dpcm(<var>number</var>);
CSS.dppx(<var>number</var>);

// &lt;flex&gt;
CSS.fr(<var>number</var>);</pre>

<h2 id="Examples">Examples</h2>

<p>We use the <code>CSS.vmax()</code> numeric factory function to create a {{domxref('CSSUnitValue')}}:</p>

<pre class="brush: js">let height = CSS.vmax(50);

console.log( height );       // CSSUnitValue {value: 50, unit: "vmax"}
console.log( height.value )  // 50
console.log( height.unit )   // vmax</pre>

<p>In this example, we set the margin on our element using the<code> CSS.px()</code> factory function:</p>

<pre class="brush: js">myElement.attributeStyleMap.set('margin', CSS.px(40));
let currentMargin = myElement.attributeStyleMap.get('margin');
console.log(currentMargin.value, currentMargin.unit); // 40, 'px'</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('CSSOM', '#numeric-factory', 'Numeric Factory Functions')}}</td>
			<td>{{Spec2('CSSOM')}}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CSS")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref('CSSUnitValue.CSSUnitValue()')}}</li>
</ul>
